#!/usr/bin/perl -w

use strict;
use DBI;

my $dbh = DBI->connect("DBI:mysql:logger","mydbuser","mydbpassword") || die "Can't Connect";


# preparation of query inserts

# page requests
$dbh->do("PREPARE p_ins FROM 'INSERT INTO logger(dataora,ipaddr,referer,browser,retcode,usertrack,language) VALUES(?,?,?,?,?,?,?)'");

# real time counter of page impression per referer
$dbh->do("PREPARE p_pcount FROM 'INSERT INTO page_counter(data,referer,counter) VALUES(CURDATE(),?,1) ON DUPLICATE KEY UPDATE counter=counter+1'");

# real time counter of single user page impressions
$dbh->do("PREPARE p_ucount FROM 'INSERT INTO user_counter(usertrack,ts_created,counter) VALUES(?,NULL,1) ON DUPLICATE KEY UPDATE counter=counter+1'");

# real time counter of per country page impressions
$dbh->do("PREPARE p_gipcount FROM 'INSERT INTO geoip_counter(data,country,counter) VALUES(CURDATE(),?,1) ON DUPLICATE KEY UPDATE counter=counter+1'");


open IN, "< -";

my %month = ('Jan','01','Feb','02','Mar','03','Apr','04','May','05','Jun','06','Jul','07','Aug','08','Sep','09','Oct','10','Nov','11','Dec','12');
my %log;

while (<IN>)
{
        # 62.10.23.42 - - [28/Oct/2002:17:50:44 +0100] "GET /img/banner/bottoni/4.gif HTTP/1.1" 304 - "http://www.inter.it/aas/news/reader?N=12263&L=it&IDINI=12290" "Mozilla/4.0 (compatible; MSIE 5.0; Windows 98; DigExt)"
        if (/^([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}) ([0-9.]+) - \[([0-9]{1,2})\/(.{3})\/([0-9]{4}):([0-9]{2}):([0-9]{2}):([0-9]{2}) \+([0-9]{4})\] \"GET ([^\b].*) HTTP\/1\..\" ([0-9]{3}) ([0-9\-]+) \"([^\"].*)\" \"([^\"].*)\"$/) {
                $log{ipaddr}    = "$1";
                $log{usertrack} = "$2";
                $log{dataora}   = "$5-$month{$4}-$3 $6:$7:$8";
                $log{getstring} = "$10";
                $log{retcode}   = "$11";
                $log{length}    = "$12";
                $log{referer}   = "$13";
                $log{referer}   =~ s/\?.*//;
                $log{referer}   =~ s/http:\/\/inter.it/http:\/\/www.inter.it/;
                $log{referer}   =~ s/http:\/\/217.169.113.132/http:\/\/www.inter.it/;
                $log{referer}   =~ s/100.inter.it/cento.inter.it/;
                $log{browser}   = "$14";

                $log{language} = $1 if ($log{referer} =~ /L=(it|en|es|cn)/i);
                $log{language} = $1 if ($log{getstring} =~ /\?(it|en|es|cn)/i);


		# execution of prepared statement in case of success web server codes
                if ( $log{retcode} =~ /(20.|30.)/ ) 
		{
                        $dbh->do("SET \@dataora='$log{dataora}', \@ipaddr='$log{ipaddr}', \@referer='$log{referer}', \@browser='$log{browser}', \@retcode='$log{retcode}', \@usertrack='$log{usertrack}', \@language='$log{language}', \@country=(SELECT getcountry('$log{ipaddr}'))");
                        $dbh->do("EXECUTE p_ins USING \@dataora, \@ipaddr, \@referer, \@browser, \@retcode, \@usertrack, \@language");
                        $dbh->do("EXECUTE p_pcount USING \@referer");
                        $dbh->do("EXECUTE p_ucount USING \@usertrack");
                        $dbh->do("EXECUTE p_gipcount USING \@country");
                }
        }
}

close IN;

